
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FlowsheetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const flowsheets = await db.flowsheets.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        version_number: data.version_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        layout_json: data.layout_json
        ||
        null
            ,
            
        approved_at: data.approved_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await flowsheets.setProject( data.project || null, {
            transaction,
        });
        
        await flowsheets.setPhase( data.phase || null, {
            transaction,
        });
        
        await flowsheets.setApproved_by( data.approved_by || null, {
            transaction,
        });
        
        await flowsheets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return flowsheets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const flowsheetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                version_number: item.version_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                layout_json: item.layout_json
            ||
            null
            ,
            
                approved_at: item.approved_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const flowsheets = await db.flowsheets.bulkCreate(flowsheetsData, { transaction });

        // For each item created, replace relation files
        

        return flowsheets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const flowsheets = await db.flowsheets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.version_number !== undefined) updatePayload.version_number = data.version_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.layout_json !== undefined) updatePayload.layout_json = data.layout_json;
        
        
        if (data.approved_at !== undefined) updatePayload.approved_at = data.approved_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await flowsheets.update(updatePayload, {transaction});

        
        
        if (data.project !== undefined) {
            await flowsheets.setProject(
              
              data.project,
              
              { transaction }
            );
        }
        
        if (data.phase !== undefined) {
            await flowsheets.setPhase(
              
              data.phase,
              
              { transaction }
            );
        }
        
        if (data.approved_by !== undefined) {
            await flowsheets.setApproved_by(
              
              data.approved_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await flowsheets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return flowsheets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const flowsheets = await db.flowsheets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of flowsheets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of flowsheets) {
                await record.destroy({transaction});
            }
        });


        return flowsheets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const flowsheets = await db.flowsheets.findByPk(id, options);

        await flowsheets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await flowsheets.destroy({
            transaction
        });

        return flowsheets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const flowsheets = await db.flowsheets.findOne(
            { where },
            { transaction },
        );

        if (!flowsheets) {
            return flowsheets;
        }

        const output = flowsheets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.flowsheet_nodes_flowsheet = await flowsheets.getFlowsheet_nodes_flowsheet({
            transaction
        });
        
        
        output.flowsheet_streams_flowsheet = await flowsheets.getFlowsheet_streams_flowsheet({
            transaction
        });
        
        
        
        output.economic_models_flowsheet = await flowsheets.getEconomic_models_flowsheet({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.project = await flowsheets.getProject({
            transaction
        });
        
        
        output.phase = await flowsheets.getPhase({
            transaction
        });
        
        
        output.approved_by = await flowsheets.getApproved_by({
            transaction
        });
        
        
        output.organizations = await flowsheets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.projects,
        as: 'project',
        
        where: filter.project ? {
          [Op.or]: [
            { id: { [Op.in]: filter.project.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.project.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.project_phases,
        as: 'phase',
        
        where: filter.phase ? {
          [Op.or]: [
            { id: { [Op.in]: filter.phase.split('|').map(term => Utils.uuid(term)) } },
            {
              gate_notes: {
                [Op.or]: filter.phase.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'approved_by',
        
        where: filter.approved_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approved_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.approved_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'flowsheets',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'flowsheets',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.layout_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'flowsheets',
                        'layout_json',
                        filter.layout_json,
                    ),
                };
            }
            

            
            

            
            if (filter.version_numberRange) {
                const [start, end] = filter.version_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    version_number: {
                    ...where.version_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    version_number: {
                    ...where.version_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.approved_atRange) {
                const [start, end] = filter.approved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.flowsheets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'flowsheets',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.flowsheets.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

